#include "lame.h"

#ifdef HAVEGTK
#include "gtkanal.h"
#include <gtk/gtk.h>
#endif


/**********************************************************************
 * read one frame and encode it 
 **********************************************************************/
int makeframe()
{
  int iread;
  static short int Buffer[2][1152];
  iread=lame_readframe(Buffer);
  /* even if iread=0, get_audio hit EOF and returned Buffer=all 0's.  call
   * makeframe() one last time to flush all buffers */
  lame_encode_tofile(Buffer);
  return iread;
}




/************************************************************************
*
* main
*
* PURPOSE:  MPEG-1,2 Layer III encoder with GPSYCHO 
* psychoacoustic model.
*
************************************************************************/


int main(argc, argv)
int     argc;
char    **argv;
{

  lame_init();
    
#ifdef ABORTFP
  {
#include <fpu_control.h>
  unsigned int mask;
  _FPU_GETCW(mask);
  /* Set the Linux mask to abort like the the FreeBSD default mask */
  mask &= ~( _FPU_MASK_IM | _FPU_MASK_ZM | _FPU_MASK_OM );
  _FPU_SETCW(mask);
  }
#endif


  
  if(argc==1)  lame_usage(argv[0]);  /* no command-line args  */
  else lame_parse_args(argc, argv); 
  lame_print_config();

#ifdef HAVEGTK
  if (gtkflag) gtk_init (&argc, &argv);
  if (gtkflag) gtkcontrol();
  else 
#endif
    {
      while (makeframe());
    }

  lame_cleanup();
  return 0;
}

