#include "lame.h"


#include "gtkanal.h"
#include <gtk/gtk.h>

#ifdef __FreeBSD__
#include <floatingpoint.h>
#endif
#ifdef ABORTFP
#include <fpu_control.h>
#endif


/**********************************************************************
 * read one frame and encode it 
 **********************************************************************/
int makeframe()
{
  int iread;
  static short int Buffer[2][1152];
  iread=lame_readframe(Buffer);
  /* if iread=0, get_audio hit EOF and returned Buffer=all 0's.  call
   * makeframe() one last time to flush all buffers */
  lame_encodeframe(Buffer);
  return iread;
}




/************************************************************************
*
* main
*
* PURPOSE:  MPEG-1,2 Layer III encoder with GPSYCHO 
* psychoacoustic model.
*
************************************************************************/


int main(argc, argv)
int     argc;
char    **argv;
{
    
  /* set some floating point masks */
#ifdef __FreeBSD__
  {
  fp_except_t mask;
  mask=fpgetmask();
  /*  printf("FreeBSD mask is 0x%x\n",mask); */
  }
#endif
#ifdef ABORTFP
  {
  unsigned int mask;
  _FPU_GETCW(mask);
  /* Set the Linux mask to the FreeBSD default mask */
  mask &= ~( _FPU_MASK_IM | _FPU_MASK_ZM | _FPU_MASK_OM );
  _FPU_SETCW(mask);
  }
#endif

  lame_init();
  
  if(argc==1)  lame_usage(argv[0]);  /* no command-line args  */
  else lame_parse_args(argc, argv); 
  lame_print_config();

  gtkflag=1;
  gtk_init (&argc, &argv);
  gtkcontrol();

  lame_cleanup();
  return 0;
}

