#ifdef HAVEGTK
#include "mpg123.h"
#include "mpglib.h"

char buf[16384]={16384*(char)0};
struct mpstr mp;

#if 0
void main(void)
{
	int size;
	char out[8192];
	int len,ret;
	

	InitMP3(&mp);

	while(1) {
		len = read(0,buf,16384);
		if(len <= 0)
			break;
		ret = decodeMP3(&mp,buf,len,out,8192,&size);
		while(ret == MP3_OK) {
			write(1,out,size);
			ret = decodeMP3(&mp,NULL,0,out,8192,&size);
		}
	}

}
#endif

int is_syncword(char *header)
{

/*
unsigned int s0,s1;
s0 = (unsigned char) header[0];
s1 = (unsigned char) header[1] ;
printf(" syncword:  %2X   %2X   \n ",s0, s1);
*/

/*
printf(" integer  %i \n",(int) ( header[0] == (char) 0xFF));
printf(" integer  %i \n",(int) ( (header[1] & (char) 0xF0) == (char) 0xF0));
*/

return 
((int) ( header[0] == (char) 0xFF)) &&
((int) ( (header[1] & (char) 0xF0) == (char) 0xF0));


}



int decode1file(int fd,short pcm[][1152],int *stereo)
{
  int size;
#define FSIZE 8192  
  char out[FSIZE];
  int outsize=0,j,i,ret,len;
  static int firstcall=1;

  size=0;
  if (firstcall) {
    InitMP3(&mp);
    firstcall=0;
    /* skip RIFF type proprietary headers  */
    /* look for sync word  FFF */
    while (!is_syncword(buf)) {
      buf[0]=buf[1]; 
      if (read(fd,&buf[1],1) <= 0) return 0;
    }
    len = 2;
  }
  else len = read(fd,buf,64); 
  if (len <=0 ) return 0;
  ret = decodeMP3(&mp,buf,len,out,FSIZE,&size);


  /* read more until we get a valid output frame */
  while((ret == MP3_NEED_MORE) || !size) {
    len = read(fd,buf,100);  
    if (len <=0 ) return 0;
    ret = decodeMP3(&mp,buf,len,out,FSIZE,&size);
    /* if (ret ==MP3_ERR) return 0;  lets ignore errors and keep reading... */
    /*
    printf("ret = %i size= %i  %i   %i  %i \n",ret,size,
	   MP3_NEED_MORE,MP3_ERR,MP3_OK); 
    */
  }

  *stereo=mp.fr.stereo;
  if (ret == MP3_OK) 
  {
    /*    write(1,out,size); */
    outsize = size/(2*(*stereo));
    if ((outsize!=576) && (outsize!=1152)) {
      fprintf(stderr,"Opps: mpg123 returned more than one frame!  Cant handle this... \n");
      exit(-50);
    }

    for (j=0; j<*stereo; j++)
      for (i=0; i<outsize; i++) 
	pcm[j][i] = ((short *) out)[*stereo*i+j];
  }
  return outsize;
}


int decode1(char *buf,int len,short pcm[][1152],int stereo)
{
  int size;
#define FSIZE 8192 
  char out[FSIZE];
  int outsize=0,j,i,ret;
  static int firstcall=1;
  
  if (firstcall) {
    InitMP3(&mp);
    firstcall=0;
  }
  
  ret = decodeMP3(&mp,buf,len,out,FSIZE,&size);
  if (ret==MP3_OK) {
    /*    printf("mpg123 output one frame out=%i \n",size/4);  */
    outsize = size/(2*stereo);
    if (outsize > 1152) {
      fprintf(stderr,"Opps: mpg123 returned more than one frame!  shouldn't happen... \n");
      exit(-50);
    }

    for (j=0; j<stereo; j++)
      for (i=0; i<outsize; i++) 
	pcm[j][i] = ((short *) out)[stereo*i+j];
  }
  /* printf("mpg123 returned %i \n",outsize); */
  return outsize;
}




#endif
