/*
 *	WavHeader for LAME.
 *
 *  Ripped for lame from Michael Beck's vplay sources (found in sndkit)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef WAVHEADER_H_INCLUDED
#define WAVHEADER_H_INCLUDED

/* Definitions for Microsoft WAVE format */

#define RIFF            0x46464952
#define WAVE            0x45564157
#define FMT             0x20746D66
#define DATA            0x61746164
#define PCM_CODE        1
#define WAVE_MONO       1
#define WAVE_STEREO     2

#define u_int unsigned int
#define u_short unsigned short
#ifdef _WIN32
	#pragma pack(push)
	#pragma pack(1)
#endif

/* it's in chunks like .voc and AMIGA iff, but my source say there
   are in only in this combination, so I combined them in one header;
   it works on all WAVE-file I have
*/
typedef struct _waveheader {
  u_int main_chunk;     /* 'RIFF' */
  u_int length;         /* filelen */
  u_int chunk_type;     /* 'WAVE' */

  u_int sub_chunk;      /* 'fmt ' */
  u_int sc_len;         /* length of sub_chunk, =16 */
  u_short       format;         /* should be 1 for PCM-code */
  u_short       modus;          /* 1 Mono, 2 Stereo */
  u_int sample_fq;      /* frequence of sample */
  u_int byte_p_sec;
  u_short       byte_p_spl;     /* samplesize; 1 or 2 bytes */
  u_short       bit_p_spl;      /* 8, 12 or 16 bit */
  u_int data_chunk;     /* 'data' */
  u_int data_length;    /* samplecount */
} WaveHeader;


#ifdef _WIN32
	#pragma pack(pop)
#endif

#endif
